import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;

import javax.crypto.Cipher;
import javax.crypto.CipherOutputStream;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.spec.IvParameterSpec;
import javax.crypto.spec.SecretKeySpec;

public class AES {

	Cipher ecipher;
	Cipher dcipher;
	byte[] buf = new byte[1024];

	public AES() {
		String strKey = "nvA9s$233eOrlQG4";
		byte[] keyBytes = null;
		try {
			keyBytes = strKey.getBytes("UTF-8");
		} catch (java.io.UnsupportedEncodingException ex) {
			ex.printStackTrace();
		}
		// byte[] iv = new byte[] { '0', '1', '2', '3', '4', '5', '6', '7', '0',
		// '1', '2', '3', '4', '5', '6', '7' };
		byte[] iv = "0123456701234567".getBytes();
		IvParameterSpec ivSpec = new IvParameterSpec(iv);
		try {
			ecipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
			dcipher = Cipher.getInstance("AES/CBC/PKCS5Padding");
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		}
		try {
			SecretKeySpec key = new SecretKeySpec(keyBytes, "AES");
			ecipher.init(Cipher.ENCRYPT_MODE, key, ivSpec);
			dcipher.init(Cipher.DECRYPT_MODE, key, ivSpec);
		} catch (InvalidKeyException e1) {
			e1.printStackTrace();
		} catch (InvalidAlgorithmParameterException e1) {
			e1.printStackTrace();
		}
	}

	public void encrypt(InputStream in, OutputStream out) {
		try {
			out = new CipherOutputStream(out, ecipher);
			int numRead = 0;
			while ((numRead = in.read(buf)) >= 0) {
				out.write(buf, 0, numRead);
			}
			out.close();
		} catch (java.io.IOException e) {
			e.printStackTrace();
		}
	}
	
	public byte[] encrptyStr(byte[] bIn) {
		try {
			return ecipher.doFinal(bIn);
		}catch (Exception e) {
			e.printStackTrace();
		}
		return new byte[]{};
	}

	public void decrypt(InputStream in, OutputStream out) {
		try {
			out = new CipherOutputStream(out, dcipher);
			int numRead = 0;
			while ((numRead = in.read(buf)) >= 0) {
				out.write(buf, 0, numRead);
			}
			out.close();
		} catch (java.io.IOException e) {
			e.printStackTrace();
		}
	}

	public byte[] decrptyStr(byte[] bIn) {
		try {
			return dcipher.doFinal(bIn);
		}catch (Exception e) {
			e.printStackTrace();
		}
		return new byte[]{};
	}	
	
	public static void main(String args[]) throws Exception {
		if (args.length != 1) {
			System.out.println("Usage: java AESEncrypter filename");
			System.exit(0);
		}

		AES encrypter = new AES();
		try {
			// encrypter.encrypt(new FileInputStream(args[0]), new
			// FileOutputStream("Java_encrypted.txt"));
			encrypter.decrypt(new FileInputStream(args[0]),
					new FileOutputStream("Java_decrypted.txt"));
		} catch (java.io.FileNotFoundException ex) {
			ex.printStackTrace();
		}
	}

	public static void main22(String args[]) throws Exception {
		AES encrypter = new AES();
		byte[] in = "yuyuyuyuyuooooooo".getBytes();		
		byte[] out = new byte[10240];
		@SuppressWarnings("unused")
		byte[] newIn = new byte[10240];
//		encrypter.encrptyStr(in, out);
		System.out.println("=====");
//		encrypter.decrptyStr(out, newIn);
//		System.out.println(new String(newIn));
	}
}
