import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.OutputStream;
import java.security.InvalidAlgorithmParameterException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.spec.InvalidKeySpecException;

import javax.crypto.Cipher;
import javax.crypto.CipherOutputStream;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;
import javax.crypto.spec.IvParameterSpec;

public class DES {

	Cipher ecipher;
	Cipher dcipher;
	byte[] buf = new byte[1024];

	public DES() {
		String strKey = "c7cbc28f2f1abf4f";
		strKey = "12345678";
		byte[] keyBytes = null;
		try {
			keyBytes = strKey.getBytes("UTF-8");
		} catch (java.io.UnsupportedEncodingException ex) {
			ex.printStackTrace();
		}
		byte[] iv = "01234567".getBytes();
		IvParameterSpec ivSpec = new IvParameterSpec(iv);
		try {
			ecipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
			dcipher = Cipher.getInstance("DES/CBC/PKCS5Padding");
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		}
		try {
			DESKeySpec dks = new DESKeySpec(keyBytes);
			SecretKeyFactory keyFactory = SecretKeyFactory.getInstance("DES");
			SecretKey securekey = keyFactory.generateSecret(dks);
			
			ecipher.init(Cipher.ENCRYPT_MODE, securekey, ivSpec);
			dcipher.init(Cipher.DECRYPT_MODE, securekey, ivSpec);
		} catch (InvalidKeyException e1) {
			e1.printStackTrace();
		} catch (InvalidAlgorithmParameterException e1) {
			e1.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (InvalidKeySpecException e) {
			e.printStackTrace();
		}
	}

	public void encrypt(InputStream in, OutputStream out) {
		try {
			out = new CipherOutputStream(out, ecipher);
			int numRead = 0;
			while ((numRead = in.read(buf)) >= 0) {
				out.write(buf, 0, numRead);
			}
			out.close();
		} catch (java.io.IOException e) {
			e.printStackTrace();
		}
	}
	
	public byte[] encrptyStr(byte[] bIn) {
		try {
			return ecipher.doFinal(bIn);
		}catch (Exception e) {
			e.printStackTrace();
		}
		return new byte[]{};
	}

	public void decrypt(InputStream in, OutputStream out) {
		try {
			out = new CipherOutputStream(out, dcipher);
			int numRead = 0;
			while ((numRead = in.read(buf)) >= 0) {
				out.write(buf, 0, numRead);
			}
			out.close();
		} catch (java.io.IOException e) {
			e.printStackTrace();
		}
	}

	public byte[] decrptyStr(byte[] bIn) {
		try {
			return dcipher.doFinal(bIn);
		}catch (Exception e) {
			e.printStackTrace();
		}
		return new byte[]{};
	}	
	
	public static void main(String args[]) throws Exception {
		if (args.length != 1) {
			System.out.println("Usage: java AESEncrypter filename");
			System.exit(0);
		}

		DES encrypter = new DES();
		try {
			encrypter.decrypt(new FileInputStream(args[0]),
					new FileOutputStream("Java_decrypted.txt"));
		} catch (java.io.FileNotFoundException ex) {
			ex.printStackTrace();
		}
	}

}
